//+------------------------------------------------------------------+
//|                                                 Level Sensor.mq4 |
//|                                          Copyright  2005, Sfen. |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Sfen"
#property indicator_chart_window
//---- input parameters
extern int MAX_HISTORY=500;
extern int STEP = 1;
extern int Xshift = 50;
extern double TargetH = 1.3585;
extern double TargetL = 1.3545;
double PointStep;
//-------------------------------------------------
int init()
{
   PointStep = 1.0*Point*STEP;
   return(0);
}
//-------------------------------------------------
double CSH(int shift)
{ return (MathMax(Open[shift],Close[shift]));   }
double CSL(int shift)
{ return (MathMin(Open[shift],Close[shift]));   }

string OBJECT_PREFIX = "LEVELS";
int ObjectId = 0;
//-------------------------------------------------
void   ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i=0; 
   while (i<ObjectsTotal())
   {
      string ObjName = ObjectName(i);
      if (StringSubstr(ObjName,0,L)!=Prefix) { i++; continue;}
      ObjectDelete(ObjName);
   }
}
//-------------------------------------------------
int deinit()
  {
   ObDeleteObjectsByPrefix(OBJECT_PREFIX);
   Comment("");
   return(0);
  }
//-------------------------------------------------
int start()
{
   string S;
   ObDeleteObjectsByPrefix(OBJECT_PREFIX);
   double HH = 0;
   double LL = 1000000;
   int History = MathMin(Bars,MAX_HISTORY);
   //
   //
   //
   int i, j, k;
   int n, nPOC, nVAH, nVAL;
   int TB_HH, TB_LL;
   double C, TB_POC, TB_VAH, TB_VAL;
   double TB_POCCount=0, TB_TotalCount=0, TB_VACount=0, VACount=0;
   
   for (i=1; i<History; i++)
   {
      HH = MathMax(HH,CSH(i));
      LL = MathMin(LL,CSL(i));
   }
   int Profile_band = (HH-LL)/PointStep+1;
   int Target_band = (TargetH-TargetL)/PointStep+1;
   int Count[],TBCount[];
   ArrayResize(Count,Profile_band);  ArrayInitialize(Count,0);
   ArrayResize(TBCount,Target_band); ArrayInitialize(TBCount,0);
   
   for (i=1; i<History; i++)
   {
      for(C=CSL(i); C<CSH(i); C+= PointStep)
      {
         n = (C-LL)/(PointStep);
         Count[n]++;    
      }
      for (j=0; j<Target_band; j++) { TBCount[j]=0;  }
      //TB_HH = (TargetH-LL)/PointStep;
      TB_LL = (TargetL-LL)/PointStep;
      for(j=0, n=TB_LL; j<Target_band; j++, n++)
      {
         TBCount[j] = Count[n];
         TB_TotalCount += TBCount[j];
         TB_VACount = MathRound(0.7 * TB_TotalCount);
         nPOC = ArrayMaximum(TBCount);
         TB_POC = TargetL + nPOC*PointStep;
         TB_POCCount = TBCount[nPOC];
      }
   }
   //
   // Calculating Value Area (VA)
   // (i let this part in bracket /* */ because it does not work, and causes PC crash,
   // so, just for reference and please check its logic structure's error --- fareastol)
   /*
      VACount = TB_POCCount;
      int upPOC = nPOC+1;
      int dnPOC = nPOC-1;

      while(VACount < TB_VACount)
      {
         if(upPOC < Target_band-1 && (dnPOC==1 || TBCount[upPOC] > TBCount[dnPOC]) )
         {
            VACount += TBCount[upPOC];
            upPOC +=1;
         }
         else if(dnPOC > 0 && (upPOC==Target_band-1 || TBCount[upPOC] < TBCount[dnPOC]) )
         {
            VACount += TBCount[dnPOC];
            dnPOC -=1;
         }
      }
      
      TB_VAH = TB_POC + upPOC*PointStep;
      TB_VAL = TB_POC - dnPOC*PointStep;
   */
   //
   //
   Comment("TargetBand(TB) = ",DoubleToStr(TargetL,Digits),"-",DoubleToStr(TargetH,Digits),"\n",
   "TB_TotalCount = ",DoubleToStr(TB_TotalCount,1),"\n","TB_VACount = ",DoubleToStr(TB_VACount,1),"\n",
   "nPOC = ",DoubleToStr(nPOC,1),"\n","TB_POC = ",DoubleToStr(TB_POC, Digits),"\n","TB_POCCount = ",DoubleToStr(TB_POCCount,1),"\n",
   "TB_VAH = ",DoubleToStr(0, Digits),"\n","TB_VAL = ",DoubleToStr(0, Digits));
   //
   //
   //
   for (i=0; i<Profile_band; i++)
   {
      double StartX = Time[0] + Xshift*60*Period();
      double StartY = LL + PointStep*i;
      datetime EndX = Time[0]+Xshift*60*Period();
      if (Count[i]<=Xshift)
            EndX -= Count[i]*Period()*60;
      else  EndX  = Time[Count[i]-Xshift];    
      double EndY   = StartY;

      string ObjName = OBJECT_PREFIX+" "+i;
      ObjectDelete(ObjName);
      ObjectCreate(ObjName,OBJ_TREND,0,StartX,StartY,EndX,EndY);
      ObjectSet(ObjName,OBJPROP_RAY,0);
      ObjectSet(ObjName,OBJPROP_COLOR,Khaki);
   }
   return(0);
}
//+------------------------------------------------------------------+


